#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Feb 20 19:39:09 2022

@author: milena
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt

## PRIMJER 1 ##

# ucitavanje podataka
data = pd.read_csv('DC.csv')
data.head()
x = data['Vin']
y = data['Vout']

plt.plot(x,y)
plt.xlabel("Vin[V]")
plt.ylabel("Vout[V]")

#izracunavanje optimalne prave metodom najmanjih kvadrata

plt.figure(1)
p = np.polyfit(x,y,1)
f = np.poly1d(p)
plt.plot(x,y, color = 'steelblue', label = 'DC transfer characteristic')
plt.plot(x,f(x), color = 'tomato', label = 'optimal line')
plt.xlabel('Vin[V]')
plt.ylabel('Vout[V]')
plt.legend()
plt.grid()

# izracunavanje i prikaz relativne greske linearnosti u procentima

plt.figure(2)
plt.plot(x,100*(y-f(x))/max(y))
plt.grid()
plt.xlabel('Vin[V]')
plt.ylabel('Relative linearity error [%]')


## PRIMJER 2 ##

data = pd.read_csv('length.csv')
data.head()
mybins= list(np.arange(99.7,100.4,0.1))
plt.hist(data['L'], bins = mybins, align='left', rwidth=0.9) 
plt.xlabel('length')
plt.ylabel('num of measurements')
plt.grid()

# Odredjivanje srednje vrijednosti, srednje devijacije i standardne 
# devijacije
srednja_vrijednost = data['L'].mean()
srednja_devijacija = data['L'].mad()
standardna_devijacija = data['L'].std()
print("srednja vrijednost: ",srednja_vrijednost)
print("srednja devijacija: ",srednja_devijacija)
print("standardna devijacija: ",standardna_devijacija)


## PRIMJER 3 ##

data = pd.read_csv('temperature.csv')
data.head()
mybins= list(np.arange(397, 406, 1))
plt.hist(data['T'], bins = mybins, align='left', rwidth=0.9) 
plt.xlabel('temperature')
plt.ylabel('num of measurements')
plt.grid()

# Odredjivanje srednje vrijednosti, srednje devijacije i standardne 
# devijacije
srednja_vrijednost = data['T'].mean()
srednja_devijacija = data['T'].mad()
standardna_devijacija = data['T'].std()
print("srednja vrijednost: ",srednja_vrijednost)
print("srednja devijacija: ",srednja_devijacija)
print("standardna devijacija: ",standardna_devijacija)

